/*
  This file is part of shuJIT,
  Just In Time compiler for Sun Java Virtual Machine.

  Copyright (C) 1996,1997,1998,1999,2000 SHUDO Kazuyuki

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  $Id$
*/

//
// Internal Opcodes
//
#define	opc_impdep1	254	// 0xfe
#define	opc_impdep2	255

#define	opc_methodhead	256	// 0x100
#define	opc_epilogue	257
#define	opc_exc_handler	258
#define	opc_methodtail	259
#define	opc_sync_enter	260
#define	opc_sync_exit	261
#define	opc_fld4	262
#define	opc_fld		263
#define	opc_fst		264
#define	opc_dld8	265
#define	opc_dld		266
#define	opc_dst		267

#define	opc_strict_enter	268
#define	opc_strict_exit		269

#define	opc_fppc_save		270
#define	opc_fppc_restore	271
#define	opc_fppc_single		272
#define	opc_fppc_double		273
#define	opc_fppc_extended	274

#define	opc_strict_fprep	275
#define	opc_strict_fscdown	276
#define	opc_strict_fscup	277
#define	opc_strict_fsettle	278
#define	opc_strict_dprep	279	// 0x117
#define	opc_strict_dscdown	280
#define	opc_strict_dscup	281
#define	opc_strict_dsettle	282

#define	opc_throw_illegalaccess	283
#define	opc_throw_noclassdef	284

#define	opc_fill_cache	285	// 0x11d
#define	opc_flush_cache	286
#define	opc_array_check	287

#define	opc_invokeignored_static	288	// 0x120
#define	opc_invokeignored_static_quick	289

#define	opc_getstatic2	290
#define	opc_putstatic2	291
#define	opc_getfield2	292
#define	opc_putfield2	293

#define	opc_iastore1	294
#define	opc_lastore1	295

#define	opc_stateto0	296
#define	opc_stateto1	297
#define	opc_stateto2	298
#define	opc_stateto3	299
#define	opc_stateto4	300

#define	opc_goto_st0	301	// 0x12d
#define	opc_goto_st1	302
#define	opc_goto_st2	303
#define	opc_goto_st3	304
#define	opc_goto_st4	305

#define	opc_sqrt	306
#define	opc_sin		307
#define	opc_cos		308
#define	opc_tan		309
#define	opc_atan2	310
#define	opc_atan	311
#define	opc_exp		312
#define	opc_log		313
#define	opc_floor	314
#define	opc_ceil	315

// for OPTIMIZE_INTERNAL_CODE
#define	opc_fload_fld	316	// 0x13c
#define opc_dload_dld	317
#define	opc_faload_fld	318
#define	opc_daload_dld	319

#define opc_istld	320
#define opc_lstld	321

#define opc_direct_invoke	322	// 0x142

#define opc_inv_head	323	// 0x143
#define opc_inv_core	324
#define opc_inv_metavm	325

#define opc_inv_vir_obj		326
#define opc_inv_vir_varspace	327
#define opc_invokevirtual_obj	328

#define opc_inv_spe_obj		329
#define opc_inv_spe_varspace	330

#define opc_inv_stq_obj		331
#define opc_inv_stq_varspace	332

#define	NOPCODES	333
